
#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

@interface igSalesmanItem : NSObject
{
    NSString* _imageName;
}
@property NSString *firstName;
@property NSString *lastName;
@property NSString *territory;
@property NSInteger yearToDateSales;
@property(nonatomic, readonly) UIImage* image;

-(id)initWithGeneratedData;
+(NSArray*)generateData:(int)count;
@end


@interface SizableSalesman : NSObject

@property(nonatomic, assign)CGSize size;
@property(nonatomic, retain)igSalesmanItem* item;

+(NSArray*)generateData:(int)count;

@end