#import "igSalesmanItem.h"

@implementation igSalesmanItem
@synthesize firstName, lastName, territory, yearToDateSales;

-(id)initWithGeneratedData
{
    if (self = [super init])
    {
        NSDictionary *pictureDictionary = [[NSDictionary alloc] initWithObjectsAndKeys:
                @"GUY", NSLocalizedString(@"Adam", @"Adam"), @"GUY", NSLocalizedString(@"Bill", @"Bill"),
                @"GUY", NSLocalizedString(@"Charlie", @"Charlie"), @"GUY", NSLocalizedString(@"Daniel", @"Daniel"),
                @"GUY", NSLocalizedString(@"Edward", @"Edward"), @"GUY", NSLocalizedString(@"Frank", @"Frank"),
                @"GIRL", NSLocalizedString(@"Alina", @"Alina"), @"GIRL", NSLocalizedString(@"Brenda", @"Brenda"),
                @"GIRL", NSLocalizedString(@"Christine", @"Christine"), @"GIRL", NSLocalizedString(@"Danielle", @"Danielle"),
                @"GIRL", NSLocalizedString(@"Erin", @"Erin"), @"GIRL", NSLocalizedString(@"Fiona", @"Fiona"),
                @"GUY", NSLocalizedString(@"Greg", @"Greg"), @"GUY", NSLocalizedString(@"Howard", @"Howard"),
                @"GUY", NSLocalizedString(@"Issac", @"Issac"), @"GUY", NSLocalizedString(@"Jack", @"Jack"),
                @"GUY", NSLocalizedString(@"Kyle", @"Kyle"), @"GUY", NSLocalizedString(@"Larry", @"Larry"),
                @"GIRL", NSLocalizedString(@"Gina", @"Gina"), @"GIRL", NSLocalizedString(@"Holly", @"Holly"),
                @"GIRL", NSLocalizedString(@"Irene", @"Irene"), @"GIRL", NSLocalizedString(@"Jennifer", @"Jennifer"),
                @"GIRL", NSLocalizedString(@"Katie", @"Katie"), @"GIRL", NSLocalizedString(@"Liz", @"Liz"),
                @"GUY", NSLocalizedString(@"Michael", @"Michael"), @"GUY", NSLocalizedString(@"Nathan", @"Nathan"),
                @"GUY", NSLocalizedString(@"Oscar", @"Oscar"), @"GUY", NSLocalizedString(@"Pete", @"Pete"),
                @"GUY", NSLocalizedString(@"Ralph", @"Ralph"), @"GUY", NSLocalizedString(@"Steve", @"Steve"),
                @"GUY", NSLocalizedString(@"Torrey", @"Torrey"), @"GUY", NSLocalizedString(@"Vince", @"Vince"),
                @"GUY", NSLocalizedString(@"William", @"William"), @"GUY", NSLocalizedString(@"Zeke", @"Zeke"), nil];
        NSArray *firstNames = [[NSArray alloc] initWithObjects:
                NSLocalizedString(@"Adam", @"Adam"), NSLocalizedString(@"Bill", @"Bill"),
                NSLocalizedString(@"Charlie", @"Charlie"), NSLocalizedString(@"Daniel", @"Daniel"),
                NSLocalizedString(@"Edward", @"Edward"), NSLocalizedString(@"Frank", @"Frank"),
                NSLocalizedString(@"Alina", @"Alina"), NSLocalizedString(@"Brenda", @"Brenda"),
                NSLocalizedString(@"Christine", @"Christine"), NSLocalizedString(@"Danielle", @"Danielle"),
                NSLocalizedString(@"Erin", @"Erin"), NSLocalizedString(@"Fiona", @"Fiona"),
                NSLocalizedString(@"Greg", @"Greg"), NSLocalizedString(@"Howard", @"Howard"),
                NSLocalizedString(@"Issac", @"Issac"), NSLocalizedString(@"Jack", @"Jack"),
                NSLocalizedString(@"Kyle", @"Kyle"), NSLocalizedString(@"Larry", @"Larry"),
                NSLocalizedString(@"Gina", @"Gina"), NSLocalizedString(@"Holly", @"Holly"),
                NSLocalizedString(@"Irene", @"Irene"), NSLocalizedString(@"Jennifer", @"Jennifer"),
                NSLocalizedString(@"Katie", @"Katie"), NSLocalizedString(@"Liz", @"Liz"),
                NSLocalizedString(@"Michael", @"Michael"), NSLocalizedString(@"Nathan", @"Nathan"),
                NSLocalizedString(@"Oscar", @"Oscar"), NSLocalizedString(@"Pete", @"Pete"),
                NSLocalizedString(@"Ralph", @"Ralph"), NSLocalizedString(@"Steve", @"Steve"),
                NSLocalizedString(@"Torrey", @"Torrey"), NSLocalizedString(@"Vince", @"Vince"),
                NSLocalizedString(@"William", @"William"), NSLocalizedString(@"Zeke", @"Zeke"), nil];
        NSUInteger randomIndex = arc4random() % [firstNames count];
        [self setFirstName:[firstNames objectAtIndex:randomIndex]];

        randomIndex = arc4random() % 24;
        if(randomIndex == 0) randomIndex = 1;
        
        NSString* number = [NSString stringWithFormat:@"%ld", (long)randomIndex];
        if(randomIndex < 10)
            number = [NSString stringWithFormat:@"0%ld", (long)randomIndex];
        
        _imageName = [NSString stringWithFormat:@"%@%@.png", [pictureDictionary valueForKey:firstName], number];
        
        NSArray *lastNames = [[NSArray alloc] initWithObjects:
                NSLocalizedString(@"Adams", @"Adams"), NSLocalizedString(@"Betts", @"Betts"),
                NSLocalizedString(@"Crowley", @"Crowley"), NSLocalizedString(@"Doran", @"Doran"),
                NSLocalizedString(@"Ellis", @"Ellis"), NSLocalizedString(@"Fitzgerald", @"Fitzgerald"),
                NSLocalizedString(@"Gable", @"Gable"), NSLocalizedString(@"Holmes", @"Holmes"),
                NSLocalizedString(@"Irvine", @"Irvine"), NSLocalizedString(@"Jefferson", @"Jefferson"),
                NSLocalizedString(@"Keefe", @"Keefe"), NSLocalizedString(@"Landry", @"Landry"),
                NSLocalizedString(@"Mendoza", @"Mendoza"), NSLocalizedString(@"Newberry", @"Newberry"),
                NSLocalizedString(@"Owens", @"Owens"), NSLocalizedString(@"Perez", @"Perez"),
                NSLocalizedString(@"Rooney", @"Rooney"), NSLocalizedString(@"Spencer", @"Spencer"),
                NSLocalizedString(@"Thomas", @"Thomas"), NSLocalizedString(@"Vargas", @"Vargas"),
                NSLocalizedString(@"Waddell", @"Waddell"), NSLocalizedString(@"Zimmerman", @"Zimmerman"), nil];
        randomIndex = arc4random() % [lastNames count];
        [self setLastName:[lastNames objectAtIndex:randomIndex]];
        
        NSArray *territories = [[NSArray alloc] initWithObjects:
                NSLocalizedString(@"Australia", @"Australia"), NSLocalizedString(@"Bulgaria", @"Bulgaria"),
                NSLocalizedString(@"Canada", @"Canada"), NSLocalizedString(@"Denmark", @"Denmark"),
                NSLocalizedString(@"Egypt", @"Egypt"), NSLocalizedString(@"France", @"France"),
                NSLocalizedString(@"Greece", @"Greece"), NSLocalizedString(@"Hungary", @"Hungary"),
                NSLocalizedString(@"Itay", @"Itay"), NSLocalizedString(@"Japan", @"Japan"),
                NSLocalizedString(@"Kenya", @"Kenya"), NSLocalizedString(@"Latvia", @"Latvia"),
                NSLocalizedString(@"Mexico", @"Mexico"), NSLocalizedString(@"Netherlands", @"Netherlands"),
                NSLocalizedString(@"Oman", @"Oman"), NSLocalizedString(@"Portugal", @"Portugal"),
                NSLocalizedString(@"Qatar", @"Qatar"), NSLocalizedString(@"Russia", @"Russia"),
                NSLocalizedString(@"Sweden", @"Sweden"), NSLocalizedString(@"Turkey", @"Turkey"),
                NSLocalizedString(@"Uruguay", @"Uruguay"), NSLocalizedString(@"Venezuela", @"Venezuela"),
                NSLocalizedString(@"Yemen", @"Yemen"), NSLocalizedString(@"Zimbabwe", @"Zimbabwe"), nil];
        randomIndex = arc4random() % [territories count];
        [self setTerritory:[territories objectAtIndex:randomIndex]];

        [self setYearToDateSales:(arc4random() % 50000)];
    }
    return self;
}

-(UIImage *)image
{
    return [UIImage imageNamed:_imageName];
}

+(NSArray*)generateData:(int)count
{
    NSMutableArray* data = [[NSMutableArray alloc]initWithCapacity:count];
    for(int i = 0; i < count; i++)
        [data addObject:[[igSalesmanItem alloc]initWithGeneratedData]];
    
    return data;
}

@end

@implementation SizableSalesman

+(NSArray*)generateData:(int)count
{
    NSMutableArray* data = [[NSMutableArray alloc]init];
    
    for(int i = 0;i < count; i++)
    {
        SizableSalesman* item = [[SizableSalesman alloc]init];
        item.size = CGSizeMake(1,1);
        item.item = [[igSalesmanItem alloc]initWithGeneratedData];
        [data addObject:item];
    }
    
    
    return data;
}

@end
